﻿using Hotline.CallCenter.BlackLists;
using Hotline.Identity.Accounts;
using Hotline.Identity.Roles;
using Hotline.KnowledgeBase;
using Hotline.Share.Dtos.CallCenter;
using Hotline.Share.Dtos.Knowledge;
using Hotline.Share.Dtos.Role;
using Hotline.Share.Dtos.User;
using Hotline.Users;
using Mapster;

namespace Hotline.Application.Mappers
{
    public class MapperConfigs : IRegister
    {
        public void Register(TypeAdapterConfig config)
        {
            config.NewConfig<AddBlacklistDto, Blacklist>()
                .Ignore(d => d.Expired)
                .AfterMapping((s, t) => t.InitExpired());

            config.NewConfig<AddUserDto, User>()
                .Map(d => d.Name, x => x.Name ?? x.UserName);

            config.NewConfig<Role, RoleDto>()
                .Map(d => d.AccountIds, x => x.Accounts.Select(d => d.Id));

            config.NewConfig<KnowledgeApply, KnowledgeApplyPageDto>()
              .Map(d => d.CreationName, x => x.User.Name)
                .Map(d => d.CreationOrgName, x => x.SystemOrganize.OrgName);

            config.NewConfig<Knowledge, KnowledgeDataDto>()
              .Map(d => d.CreationName, x => x.User.Name)
                .Map(d => d.KnowledgeTypeName, x => x.KnowledgeType.SpliceName);

            config.NewConfig<Knowledge, KnowledgeApprovalDataDto>()
            .Map(d => d.CreationName, x => x.User.Name)
              .Map(d => d.KnowledgeTypeName, x => x.KnowledgeType.SpliceName)
                 .Map(d => d.CreateBMName, x => x.SystemOrganize.OrgName);
        }
    }
}
